## eureka 2.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(CMAKE_OSX_DEPLOYMENT_TARGET "10.13" CACHE STRING "Minimum OS X deployment version")

project(eureka-editor VERSION 2.0.2)

# Why not use the latest C++
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)

add_compile_definitions(_CRT_SECURE_NO_WARNINGS)

# https://stackoverflow.com/a/66401708/11738219
function(add_path_resource target folder)
    file(GLOB_RECURSE resources "${CMAKE_CURRENT_SOURCE_DIR}/${folder}/*")
    target_sources(${target} PRIVATE ${resources})
    foreach(resfile ${resources})
        #Get the relative path from the data-folder to the particular file
        file(RELATIVE_PATH newfile "${CMAKE_CURRENT_SOURCE_DIR}/${folder}" ${resfile})

        get_filename_component(newfilepath ${newfile} DIRECTORY)
        #Set its location inside the app package (under Resources)
        set_property(SOURCE ${resfile} PROPERTY MACOSX_PACKAGE_LOCATION "Resources/${folder}/${newfilepath}")

    endforeach()
    source_group("eureka-res-clutter" FILES ${resources})
endfunction()

set(resource_common_dirs common games ports)
set(resource_common_cfgs bindings.cfg defaults.cfg operations.cfg)
set(resource_common_files ${resource_common_cfgs} misc/about_logo.png)

set(resource_common ${resource_common_dirs} ${resource_common_files})
source_group("eureka-res" FILES ${resource_common})

set_source_files_properties(${resource_common} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
# This is the main program. MACOSX_BUNDLE is needed for Mac, dummywin for Windows
add_executable(eureka MACOSX_BUNDLE ${resource_common} win/dummywin.cpp)
foreach(dir ${resource_common_dirs})
    add_path_resource(eureka common)
    add_path_resource(eureka games)
    add_path_resource(eureka ports)
endforeach()

if(WIN32)
    configure_file(src/main.rc.in src/main.rc)
    target_sources(eureka PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/src/main.rc)
    set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT eureka)
    list(TRANSFORM resource_common_cfgs PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")

    add_custom_command(
        TARGET eureka
        POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy ${resource_common_cfgs} $<TARGET_FILE_DIR:eureka>
    )
    foreach(dir ${resource_common_dirs})
        add_custom_command(
            TARGET eureka
            POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/${dir}"
                "$<TARGET_FILE_DIR:eureka>/${dir}"
        )
    endforeach()
    add_custom_command(
        TARGET eureka
        POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/misc/about_logo.png"
            "$<TARGET_FILE_DIR:eureka>/common"
    )
endif()

if(NOT APPLE)
    target_sources(eureka PRIVATE mainroot.cc)
endif()

if(APPLE)
    set(exe_display_name "Eureka Doom Editor")
    set_target_properties(eureka PROPERTIES OUTPUT_NAME "${exe_display_name}")

    add_subdirectory(osx)
    target_link_libraries(eureka eurekamac)
    set_source_files_properties(${resource_mac} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    target_sources(eureka PRIVATE ${resource_mac})

    # Use the same warnings as in the old manual project
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_BLOCK_CAPTURE_AUTORELEASING YES)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_BOOL_CONVERSION YES)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_CONSTANT_CONVERSION YES)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_EMPTY_BODY YES)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_ENUM_CONVERSION YES)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_FLOAT_CONVERSION NO)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_INFINITE_RECURSION YES)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_INT_CONVERSION YES)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_NON_LITERAL_NULL_CONVERSION YES)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_STRICT_PROTOTYPES YES)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_SUSPICIOUS_IMPLICIT_CONVERSION YES)
    set(CMAKE_XCODE_ATTRIBUTE_GCC_TREAT_IMPLICIT_FUNCTION_DECLARATIONS_AS_ERRORS YES)
    set(CMAKE_XCODE_ATTRIBUTE_GCC_TREAT_INCOMPATIBLE_POINTER_TYPE_WARNINGS_AS_ERRORS YES)
    set(CMAKE_XCODE_ATTRIBUTE_GCC_WARN_64_TO_32_BIT_CONVERSION YES)
    set(CMAKE_XCODE_ATTRIBUTE_GCC_WARN_ABOUT_RETURN_TYPE YES)
    set(CMAKE_XCODE_ATTRIBUTE_GCC_WARN_MISSING_PARENTHESES NO)  # do not want
    set(CMAKE_XCODE_ATTRIBUTE_GCC_WARN_SIGN_COMPARE YES)
    set(CMAKE_XCODE_ATTRIBUTE_GCC_WARN_UNINITIALIZED_AUTOS YES)
    set(CMAKE_XCODE_ATTRIBUTE_GCC_WARN_UNUSED_FUNCTION YES)
    set(CMAKE_XCODE_ATTRIBUTE_GCC_WARN_UNUSED_VARIABLE YES)

    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_RANGE_LOOP_ANALYSIS YES)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_WARN_SUSPICIOUS_MOVE YES)

    set_target_properties(eureka PROPERTIES
        MACOSX_BUNDLE_INFO_PLIST "${CMAKE_SOURCE_DIR}/osx/EurekaApp/Eureka Doom Editor-Info.plist.in"

        MACOSX_BUNDLE_BUNDLE_NAME "${exe_display_name}"
        MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_VERSION}"
        MACOSX_BUNDLE_COPYRIGHT "Copyright © The Eureka Team"
        MACOSX_BUNDLE_EXECUTABLE_NAME "${exe_display_name}"
        MACOSX_BUNDLE_GUI_IDENTIFIER "$(PRODUCT_BUNDLE_IDENTIFIER)"
        MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_VERSION}"
        MACOSX_BUNDLE_ICON_FILE "Eureka Doom EditorIcon"
        MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}"

        XCODE_ATTRIBUTE_PRODUCT_BUNDLE_IDENTIFIER "com.eureka.Eureka-Doom-Editor"

        XCODE_ATTRIBUTE_INSTALL_PATH "/Applications"
        XCODE_ATTRIBUTE_SKIP_INSTALL "No"
        XCODE_ATTRIBUTE_ENABLE_HARDENED_RUNTIME "YES"
        XCODE_ATTRIBUTE_CODE_SIGN_ENTITLEMENTS  ${CMAKE_SOURCE_DIR}/osx/EurekaApp/eureka.entitlements

        XCODE_ATTRIBUTE_GCC_GENERATE_DEBUGGING_SYMBOLS           "YES"
        XCODE_ATTRIBUTE_STRIP_INSTALLED_PRODUCT                  "NO"
        XCODE_ATTRIBUTE_COPY_PHASE_STRIP                  "NO"
    )

else()
    set(exe_display_name "eureka")
    if(WIN32)
        add_subdirectory(win)
    endif()
endif()

add_subdirectory(src)
if(APPLE)
    target_link_libraries(eurekasrc PRIVATE eurekamac)
    target_link_libraries(eurekamac PRIVATE eurekasrc)
endif()
if(WIN32)
    target_link_libraries(eurekasrc PRIVATE eurekawin)
endif()
target_link_libraries(eureka eurekasrc)

option(ENABLE_UNIT_TESTS "Enable unit tests" ON)
if(ENABLE_UNIT_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

# Currently, installing via CMake is only supported on GNU/Linux and similar systems
if(UNIX AND NOT APPLE)  # Linux
    set(eureka_install_dir "${CMAKE_INSTALL_PREFIX}/share/eureka")
    install(TARGETS eureka
            RUNTIME DESTINATION "${BIN_DIR}"
    )
    install(DIRECTORY games DESTINATION "${eureka_install_dir}"
            PATTERN "freedoom.ugh" EXCLUDE)
    install(DIRECTORY common ports DESTINATION "${eureka_install_dir}")
    install(FILES bindings.cfg
                  defaults.cfg
                  misc/about_logo.png
                  operations.cfg
            DESTINATION "${eureka_install_dir}"
    )
    # The full-install sequence is here
    install(CODE "execute_process(
        COMMAND xdg-desktop-menu install --novendor ${CMAKE_CURRENT_SOURCE_DIR}/misc/eureka.desktop
        COMMAND xdg-icon-resource install --novendor --size 32 ${CMAKE_CURRENT_SOURCE_DIR}/misc/eureka.xpm
    )")

    # uninstall target
    if(NOT TARGET uninstall)
        configure_file(
            "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
            IMMEDIATE @ONLY
        )

        add_custom_target(
            uninstall
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
        )
    endif()
endif()

=== src/CMakeLists.txt ===

configure_file(version.h.in version.h)

set(source_base
    dehconsts.h
    Document.cc
    Document.h
    DocumentModule.cc
    DocumentModule.h
    hdr_fltk.h
    Instance.cc
    Instance.h
    LineDef.cc
    LineDef.h
    main.cc
    main.h
    objid.h
    Sector.cc
    Sector.h
    Side.h
    SideDef.cc
    SideDef.h
    Thing.cc
    Thing.h
    Vertex.cc
    Vertex.h
    WadData.cc
    WadData.h
)

set(source_thirdparty
    filesystem.hpp
    tl/optional.hpp
)

set(source_bsp
    bsp_level.cc
    bsp_node.cc
    bsp_util.cc
    bsp.h
)

set(source_e
    e_basis.cc
    e_basis.h
    e_checks.cc
    e_checks.h
    e_commands.cc
    e_cutpaste.cc
    e_cutpaste.h
    e_hover.cc
    e_hover.h
    e_linedef.cc
    e_linedef.h
    e_main.cc
    e_main.h
    e_objects.cc
    e_objects.h
    e_path.cc
    e_path.h
    e_select.cc
    e_sector.cc
    e_sector.h
    e_things.cc
    e_things.h
    e_vertex.cc
    e_vertex.h
)

set(source_im
    im_color.cc
    im_color.h
    im_img.cc
    im_img.h
)

set(source_lib
    lib_tga.cc
    lib_tga.h
)

set(source_m
    m_config.cc
    m_config.h
    m_editlump.cc
    m_events.cc
    m_events.h
    m_files.cc
    m_files.h
    m_game.cc
    m_game.h
    m_keys.cc
    m_keys.h
    m_loadsave.cc
    m_loadsave.h
    m_nodes.cc
    m_nodes.h
    m_select.cc
    m_select.h
    m_testmap.cc
    m_testmap.h
    m_udmf.cc
)

set(source_r
    r_grid.cc
    r_grid.h
    r_opengl.cc
    r_render.cc
    r_render.h
    r_software.cc
    r_subdiv.cc
    r_subdiv.h
)

set(source_ui
    ui_about.cc
    ui_about.h
    ui_browser.cc
    ui_browser.h
    ui_canvas.cc
    ui_canvas.h
    ui_default.cc
    ui_default.h
    ui_dialog.cc
    ui_editor.cc
    ui_editor.h
    ui_file.cc
    ui_file.h
    ui_hyper.cc
    ui_hyper.h
    ui_infobar.cc
    ui_infobar.h
    ui_linedef.cc
    ui_linedef.h
    ui_menu.cc
    ui_menu.h
    ui_misc.cc
    ui_misc.h
    ui_nombre.cc
    ui_nombre.h
    ui_panelinput.cc
    ui_panelinput.h
    ui_pic.cc
    ui_pic.h
    ui_prefs.cc
    ui_prefs.h
    ui_replace.cc
    ui_replace.h
    ui_scroll.cc
    ui_scroll.h
    ui_sector.cc
    ui_sector.h
    ui_sidedef.cc
    ui_sidedef.h
    ui_thing.cc
    ui_thing.h
    ui_tile.cc
    ui_tile.h
    ui_vertex.cc
    ui_vertex.h
    ui_window.cc
    ui_window.h
)

set(source_w
    w_dehacked.cc
    w_dehacked.h
    w_loadpic.cc
    w_loadpic.h
    w_rawdef.h
    w_texture.cc
    w_texture.h
    w_wad.cc
    w_wad.h
)

add_library(
    eurekasrc STATIC
    ${source_base}
    ${source_bsp}
    ${source_e}
    ${source_im}
    ${source_lib}
    ${source_m}
    ${source_r}
    ${source_thirdparty}
    ${source_ui}
    ${source_w}
)

add_library(
    eurekacore STATIC
    Errors.cc
    Errors.h
    filesystem.hpp
    FixedPoint.h
    lib_adler.cc
    lib_adler.h
    lib_file.cc
    lib_file.h
    lib_util.cc
    lib_util.h
    m_bitvec.cc
    m_bitvec.h
    m_strings.cc
    m_strings.h
    m_parse.cc
    m_parse.h
    m_streams.cc
    m_streams.h
    m_vector.cc
    m_vector.h
    PrintfMacros.h
    SafeOutFile.cc
    SafeOutFile.h
    sys_debug.cc
    sys_debug.h
    sys_endian.h
    sys_macro.h
    sys_type.h
    WindowsSanitization.h
)

target_link_libraries(eurekasrc PRIVATE eurekacore)

# Needed for macOS release archiving!
set_target_properties(eurekasrc eurekacore PROPERTIES ARCHIVE_OUTPUT_DIRECTORY
                      ${PROJECT_BINARY_DIR}/out/library)

option(ENABLE_OPENGL "Use OpenGL instead of software rendering" ON)

if(ENABLE_OPENGL)
    find_package(OpenGL REQUIRED)
else()
    set(FLTK_SKIP_OPENGL TRUE)
    target_compile_definitions(eurekasrc PUBLIC NO_OPENGL)
endif()

if(APPLE OR WIN32)
    message(STATUS "Using local FLTK for portability.")

	set(LOCAL_FLTK_VERSION "1.3.8")
	set(LOCAL_FLTK_URL "https://www.fltk.org/pub/fltk/${LOCAL_FLTK_VERSION}/fltk-${LOCAL_FLTK_VERSION}-source.tar.gz")
	set(LOCAL_FLTK_MD5_HASH 84907602c2e50fadec3bc40fb61935cd)
	set(LOCAL_FLTK_SOURCE "${CMAKE_CURRENT_BINARY_DIR}/fltk-${LOCAL_FLTK_VERSION}")

    set(LOCAL_FLTK_ARCHIVE "${CMAKE_CURRENT_BINARY_DIR}/fltk-${LOCAL_FLTK_VERSION}-source.tar.gz")
    set(LOCAL_FLTK_BUILD "${LOCAL_FLTK_SOURCE}/build")

    # Download it if not found
    if(NOT EXISTS "${LOCAL_FLTK_ARCHIVE}")
        message(STATUS "Downloading FLTK from ${LOCAL_FLTK_URL}")
        file(
            DOWNLOAD ${LOCAL_FLTK_URL} "${LOCAL_FLTK_ARCHIVE}"
            EXPECTED_HASH MD5=${LOCAL_FLTK_MD5_HASH}
        )
    endif()
    if(NOT EXISTS "${LOCAL_FLTK_SOURCE}")
        message(STATUS "Extracting to ${LOCAL_FLTK_SOURCE}")
        execute_process(
            COMMAND "${CMAKE_COMMAND}" -E tar xzf "${LOCAL_FLTK_ARCHIVE}"
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        )
        # Patch needed to prevent optimization bug
        if(APPLE)
            execute_process(
                COMMAND patch "${LOCAL_FLTK_SOURCE}/src/Fl_JPEG_Image.cxx"
                              "${CMAKE_CURRENT_SOURCE_DIR}/fltk-patch/Fl_JPEG_Image-fltk1.3.8-macos.diff"
            )
        endif()
    endif()
    if(NOT EXISTS "${LOCAL_FLTK_BUILD}/lib")

        message(STATUS "Building ${LOCAL_FLTK_SOURCE}")

        set(LOCAL_FLTK_DEFS -D CMAKE_OSX_DEPLOYMENT_TARGET=${CMAKE_OSX_DEPLOYMENT_TARGET}
                            -D CMAKE_OSX_ARCHITECTURES=${CMAKE_OSX_ARCHITECTURES}
                            -D CMAKE_BUILD_TYPE=Release
                            -D OPTION_USE_SYSTEM_LIBJPEG=OFF -D OPTION_USE_SYSTEM_LIBPNG=OFF
                            -D OPTION_USE_SYSTEM_ZLIB=OFF
        )
        if(CMAKE_GENERATOR_PLATFORM)
            list(APPEND LOCAL_FLTK_DEFS -A ${CMAKE_GENERATOR_PLATFORM})
        endif()
        if(FLTK_SKIP_OPENGL)
            list(APPEND LOCAL_FLTK_DEFS -D OPTION_USE_GL=OFF)
        endif()
        if(WIN32)
            list(APPEND LOCAL_FLTK_DEFS -G ${CMAKE_GENERATOR})
        endif()

        execute_process(
            COMMAND "${CMAKE_COMMAND}" -S "${LOCAL_FLTK_SOURCE}" -B "${LOCAL_FLTK_BUILD}"
                    ${LOCAL_FLTK_DEFS}
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        )
        include(ProcessorCount)
        ProcessorCount(nproc)
        message(STATUS "Building...")
        execute_process(
            COMMAND "${CMAKE_COMMAND}" --build "${LOCAL_FLTK_BUILD}" -j ${nproc} --config Release
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        )
    endif()

    set(FLTK_INCLUDE_DIR "${LOCAL_FLTK_SOURCE};${LOCAL_FLTK_BUILD}")
    if(WIN32)
        set(FLTK_LIBRARIES "${LOCAL_FLTK_BUILD}/lib/Release/fltk.lib"
                           "${LOCAL_FLTK_BUILD}/lib/Release/fltk_gl.lib"
                           "${LOCAL_FLTK_BUILD}/lib/Release/fltk_images.lib"
                           "${LOCAL_FLTK_BUILD}/lib/Release/fltk_jpeg.lib"
                           "${LOCAL_FLTK_BUILD}/lib/Release/fltk_png.lib"
                           "${LOCAL_FLTK_BUILD}/lib/Release/fltk_z.lib"
        )
        target_include_directories(eurekasrc PUBLIC "${LOCAL_FLTK_SOURCE}/zlib")
    else()  # APPLE
        set(FLTK_LIBRARIES "${LOCAL_FLTK_BUILD}/lib/libfltk.a"
                           "${LOCAL_FLTK_BUILD}/lib/libfltk_gl.a"
                           "${LOCAL_FLTK_BUILD}/lib/libfltk_images.a"
                           "${LOCAL_FLTK_BUILD}/lib/libfltk_jpeg.a"
                           "${LOCAL_FLTK_BUILD}/lib/libfltk_z.a"
                           "${LOCAL_FLTK_BUILD}/lib/libfltk_png.a"
        )

        # Need to link to them separately if FLTK is linked manually
        find_library(CARBON_FRAMEWORK Carbon)
        target_link_libraries(eurekasrc PUBLIC ${CARBON_FRAMEWORK})
        find_library(COCOA_FRAMEWORK Cocoa)
        target_link_libraries(eurekasrc PUBLIC ${COCOA_FRAMEWORK})
        find_library(APPSERVICES_FRAMEWORK ApplicationServices)
        target_link_libraries(eurekasrc PUBLIC ${APPSERVICES_FRAMEWORK})
    endif()

else()
    # UNIX/Linux
    find_package(FLTK REQUIRED)
    find_package(ZLIB REQUIRED) # ZLIB is expected on Linux separately from FLTK
    find_package(X11 REQUIRED)  # also libXPM
endif()

target_link_libraries(eurekasrc PUBLIC ${FLTK_LIBRARIES} ${OPENGL_LIBRARIES})
if(UNIX AND NOT APPLE)  # Linux
    target_link_libraries(eurekasrc PUBLIC ${X11_Xpm_LIB} ${ZLIB_LIBRARIES})
endif()

target_include_directories(eurekasrc PUBLIC
    ${PROJECT_SOURCE_DIR}
    ${FLTK_INCLUDE_DIR}
    ${OPENGL_INCLUDE_DIR}
)

# May be needed by files from other projects to find headers here
target_include_directories(eurekasrc PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}")
target_include_directories(eurekasrc PUBLIC "${CMAKE_CURRENT_BINARY_DIR}")

if(MSVC)
    target_compile_options(eurekasrc PUBLIC "/MP")
endif()

if ( CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "GNU" )
    target_compile_options(eurekasrc PUBLIC "${CMAKE_CXX_FLAGS}" -Wall -Wextra -Werror
                           -Wno-unused-parameter -Wno-missing-field-initializers -Wunused-variable)
endif()
if ( MSVC )
    # TODO: make remove /W3 if there and set /W4
    #target_compile_options(eurekasrc PUBLIC ${CMAKE_CXX_FLAGS} /W4)
endif()

source_group(bsp FILES ${source_bsp})
source_group("e_ source" FILES ${source_e})
source_group("im_ source" FILES ${source_im})
source_group("lib_ source" FILES ${source_lib})
source_group("im_ source" FILES ${source_im})
source_group("lib_ source" FILES ${source_lib})
source_group("m_ source" FILES ${source_m})
source_group("r_ source" FILES ${source_r})
source_group("ui_ source" FILES ${source_ui})
source_group("w_ source" FILES ${source_w})
source_group("third-party" FILES ${source_thirdparty})

# TODO: add the warnings and warnings-as-errors

=== test/CMakeLists.txt ===
message(STATUS "Enable testing: ${ENABLE_UNIT_TESTS}")

# Following https://github.com/google/googletest/blob/main/googletest/README.md
include(FetchContent)
FetchContent_Declare(
    googletest
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG v1.14.0
)
# For Windows: Prevent overriding the parent project's compiler/linker settings
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
FetchContent_MakeAvailable(googletest)


set(src ${CMAKE_SOURCE_DIR}/src)
get_target_property(src_includes eurekasrc INCLUDE_DIRECTORIES)
get_target_property(fltk_libs eurekasrc LINK_LIBRARIES)
get_target_property(eureka_compile_options eurekasrc COMPILE_OPTIONS)
list(FILTER fltk_libs INCLUDE REGEX fltk)

# This is the common testing library. Contains whatever's in testUtils and some very common
# eurekasrc files

add_library(
    testutils
    STATIC
    testUtils/FatalHandler.cpp
    testUtils/FatalHandler.hpp
    testUtils/TempDirContext.cpp
    testUtils/TempDirContext.hpp
    testUtils/Palette.cpp
    testUtils/Palette.hpp
)
target_link_libraries(testutils PUBLIC gtest_main eurekacore)
if(WIN32)
    target_link_libraries(testutils PUBLIC Rpcrt4.lib)
endif()
target_include_directories(testutils PUBLIC ${src} ${src_includes})
target_compile_options(testutils PUBLIC ${eureka_compile_options})
# Need to link to them separately if FLTK is linked manually
if(APPLE)
    find_library(CARBON_FRAMEWORK Carbon)
    target_link_libraries(testutils PUBLIC ${CARBON_FRAMEWORK})
    find_library(COCOA_FRAMEWORK Cocoa)
    target_link_libraries(testutils PUBLIC ${COCOA_FRAMEWORK})
    find_library(APPSERVICES_FRAMEWORK ApplicationServices)
    target_link_libraries(testutils PUBLIC ${APPSERVICES_FRAMEWORK})
endif()

add_executable(
    test_general
    DocumentTest.cpp
    e_checks_test.cpp
    e_commands_test.cpp
    e_cutpaste_test.cpp
    e_linedef_test.cpp
    e_objects_test.cpp
    FixedPointTest.cpp
    im_color_test.cpp
    im_img_test.cpp
    lib_file_test.cpp
    lib_tga_test.cpp
    lib_util_test.cpp
    m_bitvec_test.cpp
    m_files_test.cpp
    m_game_test.cpp
    m_parse_test.cpp
    m_select_test.cpp
    m_streams_test.cpp
    m_testmap_test.cpp
    main_test.cpp
    r_grid_test.cpp
	SafeOutFileTest.cpp
    SectorTest.cpp
    SideTest.cpp
    SStringTest.cpp
    StringTableTest.cpp
    sys_debug_test.cpp
    ThingTest.cpp
    VertexTest.cpp
    w_dehacked_test.cpp
    w_loadpic_test.cpp
    w_texture_test.cpp
    w_wad_test.cpp
    WadDataTest.cpp
    stub/osxcalls_stub.cpp
)
target_link_libraries(test_general PRIVATE testutils eurekasrc)
if(APPLE)
    # Need to get access to the OSXCalls.h stuff
    target_include_directories(test_general PRIVATE ${CMAKE_SOURCE_DIR}/osx/EurekaApp)
    target_compile_definitions(test_general PRIVATE GL_SILENCE_DEPRECATION)
endif()
target_compile_definitions(test_general PUBLIC NO_OPENGL)
target_link_libraries(test_general PRIVATE ${fltk_libs})
if(UNIX AND NOT APPLE)
    find_package(ZLIB REQUIRED)
    find_package(X11 REQUIRED)
    target_link_libraries(test_general PRIVATE ${X11_X11_LIB} ${X11_Xpm_LIB} ${ZLIB_LIBRARIES})
endif()

add_test(NAME test_general COMMAND $<TARGET_FILE:test_general>)


# IMPORTANT: the eurekasrc files from testutils are already linked!


# unit_test(m_config_keys
#     m_config_test.cpp
#     m_keys_test.cpp
#     SRC im_color.cc
#         im_img.cc
#         lib_file.cc
#         m_config.cc
#         m_keys.cc
#         m_parse.cc
#         m_streams.cc
#         SafeOutFile.cc
#         w_wad.cc
#     FLTK
# )

find_package(Python3)
if(NOT Python3_FOUND)
    message(WARNING "Python 3 not found, will not run system tests.")
else()
    add_test(NAME system_test_print_quit COMMAND ${Python3_EXECUTABLE}
        ${CMAKE_CURRENT_SOURCE_DIR}/python/test_print_quit.py
        --executable $<TARGET_FILE:eureka>
        --version ${PROJECT_VERSION}
    )
endif()

=== debian/changelog ===
eureka (2.0.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Update standards version to 4.6.1, no changes needed.

  [ Fabian Greffrath ]
  * Follow upstream take over of the project to github
  * Update debian/watch file
  * New upstream version 2.0.2
  * Update debian/copyright
  * Update Build-Depends on libgl-dev, add cmake, fluid and libxpm-dev
  * Build without unit tests, update file locations
  * Build without -Werror, do not duplicate CXXFLAGS
  * Add Forwarded status to patches
  * Bump Standards-Version to 4.6.2

 -- Fabian Greffrath <fabian@debian.org>  Wed, 24 Jul 2024 08:48:53 +0200

=== debian/control ===
Source: eureka
Section: utils
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Fabian Greffrath <fabian@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 fluid,
 libfltk1.3-dev,
 libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libxpm-dev,
 zlib1g-dev | libz-dev
Standards-Version: 4.6.2
Homepage: https://github.com/ioan-chera/eureka-editor
Vcs-Browser: https://salsa.debian.org/games-team/eureka
Vcs-Git: https://salsa.debian.org/games-team/eureka.git
Rules-Requires-Root: no

Package: eureka
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: freedoom | game-data-packager
Description: map editor for the classic DOOM games
 Eureka is a cross-platform map editor for the classic DOOM games.
 It started as a fork of the Yadex editor attempting to make it use the
 FLTK GUI toolkit and implement multiple Undo / Redo.
 .
 Supported games include DOOM, DOOM 2, Final Doom, FreeDoom, HacX and Heretic.
 Supported source ports are Boom, EDGE, Doom Legacy and Odamex.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_UNIT_TESTS=OFF

override_dh_auto_install:
	dh_auto_install -- \
		DESTDIR=$(CURDIR)/debian/eureka \
		PREFIX=/usr

override_dh_installchangelogs:
	dh_installchangelogs changelogs/$(DEB_VERSION_UPSTREAM).md

override_dh_installdocs:
	dh_installdocs AUTHORS.md README.txt

override_dh_installman:
	dh_installman misc/eureka.6

=== debian/watch ===
version=4
https://github.com/ioan-chera/eureka-editor/tags \
https://github.com/ioan-chera/eureka-editor/archive/refs/tags/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## eureka 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.28)
 
 set(CMAKE_OSX_DEPLOYMENT_TARGET "10.13" CACHE STRING "Minimum OS X deployment version")
 
-project(eureka-editor VERSION 2.0.2)
+project(eureka-editor VERSION 2.1.0)
 
 # Why not use the latest C++
 set(CMAKE_CXX_STANDARD 17)
@@ -139,6 +139,9 @@
 endif()
 
 add_subdirectory(src)
+if(UNIX AND NOT APPLE)  # Linux
+    target_include_directories(eurekasrc PRIVATE /usr/include/cairo)
+endif()
 if(APPLE)
     target_link_libraries(eurekasrc PRIVATE eurekamac)
     target_link_libraries(eurekamac PRIVATE eurekasrc)

=== osx/CMakeLists.txt ===
add_subdirectory(EurekaApp)

=== src/CMakeLists.txt ===

configure_file(version.h.in version.h)

set(source_base
    dehconsts.h
    Document.cc
    Document.h
    DocumentModule.cc
    DocumentModule.h
    hdr_fltk.h
    Instance.cc
    Instance.h
    LineDef.cc
    LineDef.h
    main.cc
    main.h
    objid.h
    Sector.cc
    Sector.h
    Side.h
    SideDef.cc
    SideDef.h
    Thing.cc
    Thing.h
    Vertex.cc
    Vertex.h
    WadData.cc
    WadData.h
)

set(source_thirdparty
    filesystem.hpp
    tl/optional.hpp
)

set(source_bsp
    bsp_level.cc
    bsp_node.cc
    bsp_util.cc
    bsp.h
)

set(source_e
    e_basis.cc
    e_basis.h
    e_checks.cc
    e_checks.h
    e_commands.cc
    e_cutpaste.cc
    e_cutpaste.h
    e_hover.cc
    e_hover.h
    e_linedef.cc
    e_linedef.h
    e_main.cc
    e_main.h
    e_objects.cc
    e_objects.h
    e_path.cc
    e_path.h
    e_select.cc
    e_sector.cc
    e_sector.h
    e_things.cc
    e_things.h
    e_vertex.cc
    e_vertex.h
)

set(source_im
    im_color.cc
    im_color.h
    im_img.cc
    im_img.h
)

set(source_lib
    lib_tga.cc
    lib_tga.h
)

set(source_m
    m_config.cc
    m_config.h
    m_editlump.cc
    m_events.cc
    m_events.h
    m_files.cc
    m_files.h
    m_game.cc
    m_game.h
    m_keys.cc
    m_keys.h
    m_loadsave.cc
    m_loadsave.h
    m_nodes.cc
    m_nodes.h
    m_select.cc
    m_select.h
    m_testmap.cc
    m_testmap.h
    m_udmf.cc
)

set(source_r
    r_grid.cc
    r_grid.h
    r_opengl.cc
    r_render.cc
    r_render.h
    r_software.cc
    r_subdiv.cc
    r_subdiv.h
)

set(source_ui
    ui_about.cc
    ui_about.h
    ui_browser.cc
    ui_browser.h
    ui_canvas.cc
    ui_canvas.h
    ui_default.cc
    ui_default.h
    ui_dialog.cc
    ui_editor.cc
    ui_editor.h
    ui_file.cc
    ui_file.h
    ui_hyper.cc
    ui_hyper.h
    ui_infobar.cc
    ui_infobar.h
    ui_keybindingstable.cc
    ui_keybindingstable.h
    ui_linedef.cc
    ui_linedef.h
    ui_menu.cc
    ui_menu.h
    ui_misc.cc
    ui_misc.h
    ui_nombre.cc
    ui_nombre.h
    ui_panelinput.cc
    ui_panelinput.h
    ui_pic.cc
    ui_pic.h
    ui_prefs.cc
    ui_replace.cc
    ui_replace.h
    ui_scroll.cc
    ui_scroll.h
    ui_sector.cc
    ui_sector.h
    ui_sidedef.cc
    ui_sidedef.h
    ui_thing.cc
    ui_thing.h
    ui_tile.cc
    ui_tile.h
    ui_vertex.cc
    ui_vertex.h
    ui_window.cc
    ui_window.h
)

set(source_w
    w_dehacked.cc
    w_dehacked.h
    w_loadpic.cc
    w_loadpic.h
    w_rawdef.h
    w_texture.cc
    w_texture.h
    w_wad.cc
    w_wad.h
)

add_library(
    eurekasrc STATIC
    ${source_base}
    ${source_bsp}
    ${source_e}
    ${source_im}
    ${source_lib}
    ${source_m}
    ${source_r}
    ${source_thirdparty}
    ${source_ui}
    ${source_w}
)

add_library(
    eurekacore STATIC
    Errors.cc
    Errors.h
    filesystem.hpp
    FixedPoint.h
    lib_adler.cc
    lib_adler.h
    lib_file.cc
    lib_file.h
    lib_util.cc
    lib_util.h
    m_bitvec.cc
    m_bitvec.h
    m_strings.cc
    m_strings.h
    m_parse.cc
    m_parse.h
    m_streams.cc
    m_streams.h
    m_vector.cc
    m_vector.h
    PrintfMacros.h
    safe_ctype.cc
    safe_ctype.h
    SafeOutFile.cc
    SafeOutFile.h
    sys_debug.cc
    sys_debug.h
    sys_endian.h
    sys_macro.h
    sys_type.h
    WindowsSanitization.h
)

target_link_libraries(eurekasrc PRIVATE eurekacore)

# Needed for macOS release archiving!
set_target_properties(eurekasrc eurekacore PROPERTIES ARCHIVE_OUTPUT_DIRECTORY
                      ${PROJECT_BINARY_DIR}/out/library)

option(ENABLE_OPENGL "Use OpenGL instead of software rendering" ON)

if(ENABLE_OPENGL)
    find_package(OpenGL REQUIRED)
else()
    set(FLTK_SKIP_OPENGL TRUE)
    target_compile_definitions(eurekasrc PUBLIC NO_OPENGL)
endif()

#
# Fetch FLTK
#

option(USE_SYSTEM_FLTK "Use system FLTK instead of locally-fetched source")
if(USE_SYSTEM_FLTK)
    message(STATUS "Using system FLTK.")
    find_package(FLTK REQUIRED)
    message(VERBOSE "Found FLTK_INCLUDE_DIR ${FLTK_INCLUDE_DIR}")
    message(VERBOSE "Found FLTK_LIBRARIES ${FLTK_LIBRARIES}")
    message(VERBOSE "Found FLTK_FLUID_EXECUTABLE ${FLTK_FLUID_EXECUTABLE}")
    set(LOCAL_FLTK_INSTALL_LIBS X11)    # Extra libraries needed with 1.3
else()
    message(STATUS "Using fetch-content FLTK for portability.")
    include(FetchContent)

    FetchContent_Declare(
        FLTK
        GIT_REPOSITORY https://github.com/fltk/fltk.git
        GIT_TAG release-1.4.4
        EXCLUDE_FROM_ALL
    )
    FetchContent_MakeAvailable(FLTK)
endif()

target_include_directories(
    eurekasrc
    PUBLIC
    ${fltk_BINARY_DIR}
    ${fltk_SOURCE_DIR}
    ${FLTK_INCLUDE_DIR}
)
target_link_libraries(
    eurekasrc
    PRIVATE
    fltk fltk_gl fltk_images ${LOCAL_FLTK_INSTALL_LIBS}
)

if(APPLE)
    # Need to link to them separately if FLTK is linked manually
    find_library(CARBON_FRAMEWORK Carbon)
    target_link_libraries(eurekasrc PUBLIC ${CARBON_FRAMEWORK})
    find_library(COCOA_FRAMEWORK Cocoa)
    target_link_libraries(eurekasrc PUBLIC ${COCOA_FRAMEWORK})
    find_library(APPSERVICES_FRAMEWORK ApplicationServices)
    target_link_libraries(eurekasrc PUBLIC ${APPSERVICES_FRAMEWORK})
    find_package(ZLIB REQUIRED)
    target_link_libraries(eurekasrc PUBLIC ${ZLIB_LIBRARIES})
endif()

if(UNIX AND NOT APPLE)
    find_package(X11 REQUIRED)  # also libXPM
    find_package(ZLIB REQUIRED) # ZLIB is expected on Linux separately from FLTK
    find_package(JPEG REQUIRED)
    find_package(PNG REQUIRED)
    target_link_libraries(
        eurekasrc
        PUBLIC
        ${X11_Xpm_LIB}
        ${ZLIB_LIBRARIES}
        ${JPEG_LIBRARIES}
        ${PNG_LIBRARIES}
    )
else()
    target_link_libraries(
        eurekasrc
        PRIVATE
        fltk_jpeg fltk_png fltk_z
    )
    target_include_directories(
        eurekasrc
        PUBLIC
        ${fltk_SOURCE_DIR}/zlib
    )
endif()

target_link_libraries(eurekasrc PUBLIC ${OPENGL_LIBRARIES})

target_include_directories(eurekasrc PUBLIC
    ${PROJECT_SOURCE_DIR}
    ${OPENGL_INCLUDE_DIR}
)

# May be needed by files from other projects to find headers here
target_include_directories(eurekasrc PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}")
target_include_directories(eurekasrc PUBLIC "${CMAKE_CURRENT_BINARY_DIR}")

if(MSVC)
    target_compile_options(eurekasrc PUBLIC "/MP")
endif()

if ( CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "GNU" )
    target_compile_options(eurekasrc PUBLIC -Wall -Wextra -Werror
                           -Wno-unused-parameter -Wno-missing-field-initializers -Wunused-variable)
endif()
if ( MSVC )
    # TODO: make remove /W3 if there and set /W4
    #target_compile_options(eurekasrc PUBLIC ${CMAKE_CXX_FLAGS} /W4)
endif()

source_group(bsp FILES ${source_bsp})
source_group("e_ source" FILES ${source_e})
source_group("im_ source" FILES ${source_im})
source_group("lib_ source" FILES ${source_lib})
source_group("im_ source" FILES ${source_im})
source_group("lib_ source" FILES ${source_lib})
source_group("m_ source" FILES ${source_m})
source_group("r_ source" FILES ${source_r})
source_group("ui_ source" FILES ${source_ui})
source_group("w_ source" FILES ${source_w})
source_group("third-party" FILES ${source_thirdparty})

# TODO: add the warnings and warnings-as-errors

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,28 @@
 message(STATUS "Enable testing: ${ENABLE_UNIT_TESTS}")
 
-# Following https://github.com/google/googletest/blob/main/googletest/README.md
-include(FetchContent)
-FetchContent_Declare(
-    googletest
-    GIT_REPOSITORY https://github.com/google/googletest.git
-    GIT_TAG v1.14.0
-)
-# For Windows: Prevent overriding the parent project's compiler/linker settings
-set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
-FetchContent_MakeAvailable(googletest)
-
+option(USE_SYSTEM_GOOGLE_TEST "Use system Google Test instead of locally-fetched source.")
+if(USE_SYSTEM_GOOGLE_TEST)
+    message(STATUS "Using system Google Test.")
+    find_package(GTest REQUIRED)
+    message(VERBOSE "Found GTEST_INCLUDE_DIRS ${GTEST_INCLUDE_DIRS}")
+    message(VERBOSE "Found GTEST_LIBRARIES ${GTEST_LIBRARIES}")
+    message(VERBOSE "Found GTEST_MAIN_LIBRARIES ${GTEST_MAIN_LIBRARIES}")
+    message(VERBOSE "Found GTEST_BOTH_LIBRARIES ${GTEST_BOTH_LIBRARIES}")
+    add_library(gtest_main ALIAS GTest::gtest_main)
+else()
+    message(STATUS "Using fetch-content Google Test for portability.")
+    # Following https://github.com/google/googletest/blob/main/googletest/README.md
+    include(FetchContent)
+    FetchContent_Declare(
+        googletest
+        GIT_REPOSITORY https://github.com/google/googletest.git
+        GIT_TAG v1.14.0
+        EXCLUDE_FROM_ALL
+    )
+    # For Windows: Prevent overriding the parent project's compiler/linker settings
+    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
+    FetchContent_MakeAvailable(googletest)
+endif()
 
 set(src ${CMAKE_SOURCE_DIR}/src)
 get_target_property(src_includes eurekasrc INCLUDE_DIRECTORIES)
@@ -50,6 +62,7 @@
 add_executable(
     test_general
     DocumentTest.cpp
+    e_basis_test.cpp
     e_checks_test.cpp
     e_commands_test.cpp
     e_cutpaste_test.cpp
@@ -62,8 +75,10 @@
     lib_tga_test.cpp
     lib_util_test.cpp
     m_bitvec_test.cpp
+    m_events_test.cpp
     m_files_test.cpp
     m_game_test.cpp
+    m_keys_test.cpp
     m_parse_test.cpp
     m_select_test.cpp
     m_streams_test.cpp

=== win/CMakeLists.txt ===
add_library(eurekawin STATIC include/GL/glext.h include/KHR/khrplatform.h dummywin.cpp)
target_include_directories(eurekawin PUBLIC include)
set_target_properties(eurekawin PROPERTIES LINKER_LANGUAGE CXX)

=== osx/EurekaApp/CMakeLists.txt ===
set(resource_mac "${CMAKE_CURRENT_SOURCE_DIR}/Eureka Doom EditorIcon.icns" CACHE FILEPATH "")
set(source_mac
    AppDelegate.h
    AppDelegate.mm
    OSXCalls.h
    OSXCalls.mm
)

add_library(eurekamac STATIC ${source_mac})

# Needed for macOS release archiving!
set_target_properties(eurekamac PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/out/library)

target_include_directories(eurekamac INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
# Need to silence OpenGL deprecation warnings (they tell us what we know and can't fix)
target_compile_definitions(eurekamac PUBLIC
    "GL_SILENCE_DEPRECATION"
)

=== debian/changelog ===
eureka (2.1.0-2) unstable; urgency=medium

  * Add two post-release patches from upstream:
    + Fixed failure to run on aarch64 systems
    + Fixed fatal error happening when loading DEHACKED lumps with
      unnamed thing entries (Closes: #1118948)

 -- Fabian Greffrath <fabian@debian.org>  Wed, 29 Oct 2025 21:21:25 +0100

eureka (2.1.0-1) unstable; urgency=medium

  * Update debian/watch file to version 5
  * New upstream version 2.1.0
  * Build-Depend on libfltk1.4-dev (Closes: #1102742)
  * Remove patches applied upstream
  * Fix reproducubility by defining BUILD_YEAR and BUILD_DATE, refresh
    patch
  * Enforce USE_SYSTEM_FLTK=ON
  * Bump Standards-Version to 4.7.2
  * Remove redundant RRR: no
  * Update Debian packaging copyright
  * Add Build-Depends on libjpeg-dev
  * Run wrap-and-sort

 -- Fabian Greffrath <fabian@debian.org>  Fri, 17 Oct 2025 09:32:02 +0200

=== debian/control ===
Source: eureka
Section: utils
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Fabian Greffrath <fabian@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 fluid,
 libfltk1.4-dev,
 libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libjpeg-dev,
 libxpm-dev,
 zlib1g-dev | libz-dev
Standards-Version: 4.7.2
Homepage: https://github.com/ioan-chera/eureka-editor
Vcs-Browser: https://salsa.debian.org/games-team/eureka
Vcs-Git: https://salsa.debian.org/games-team/eureka.git

Package: eureka
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 freedoom | game-data-packager
Description: map editor for the classic DOOM games
 Eureka is a cross-platform map editor for the classic DOOM games.
 It started as a fork of the Yadex editor attempting to make it use the
 FLTK GUI toolkit and implement multiple Undo / Redo.
 .
 Supported games include DOOM, DOOM 2, Final Doom, FreeDoom, HacX and Heretic.
 Supported source ports are Boom, EDGE, Doom Legacy and Odamex.

=== debian/watch ===
Version: 5
Template: GitHub
Owner: ioan-chera
Project: eureka-editor
